package org.qatools.remote;

import java.util.Arrays;
import java.util.List;

import org.apache.log4j.Logger;
import org.qatools.util.QAToolsUtil;
import org.qatools.util.SshUtil;

public abstract class RemoteDirUtil extends QAToolsUtil {
    private static Logger sLogger = Logger.getLogger(RemoteDirUtil.class);

    
	// -------------------------------------------------------------
	// ----- ls
	// -------------------------------------------------------------

    /**
     * Returns a file listing of the remote directory
     */
    public static List<String> ls(RemoteDir rd) {
    	return SshUtil.runCommandGetResults(rd, "ls " + rd.getDir());
    }

    /**
     * Returns a file listing of the remote directory matching the pattern
     */
    public static List<String> ls(RemoteDir rd, String filePattern) {
    	return SshUtil.runCommandGetResults(rd, "cd " + rd.getDir () + "; ls " + filePattern);
    }

	// -------------------------------------------------------------
	// ----- grep - in every file in the ir
	// -------------------------------------------------------------

    /**
     * 
     * @param rd
     * @param str
     * @return
     */
    public static List<String> grep(RemoteDir rd, String str) {
    	return grep(rd, Arrays.asList(str));
    }
    
    /**
     * 
     * @param rd
     * @param list
     * @return
     */
    public static List<String> grep(RemoteDir rd, List<String> list) {
    	if (rd==null || list==null || list.size()==0) {
    		return null;
    	}
    	String cmd = "cd " + rd.getDir() + "; grep \"" + list.get(0) + "\" *";
    	
    	for (int i=1; i<list.size(); i++) {
    		cmd += " | grep \"" + list.get(i) + "\"";
    	}
    	return SshUtil.runCommandGetResults(rd, cmd);
    }

}
